//Minigun.cs

datablock AudioProfile(MinigunExplosionSound)
{
   filename    = "~/data/sound/Impact1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MinigunFireSound)
{
   filename    = "~/data/sound/arrowHit.wav";
   description = AudioClosest3d;
   preload = true;
};


//bullet trail
datablock ParticleData(MinigunTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 0;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "~/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "0.9 0.9 0.9 0.9";
	colors[1]	= "0.9 0.9 0.9 0.9";
	sizes[0]	= 0.2;
	sizes[1]	= 0.01;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(MinigunTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;

   ejectionVelocity = 90; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = MinigunTrailParticle;
};

//effects
datablock ParticleData(MinigunExplosionParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "~/data/particles/chunk";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.6 0.9";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.0;
};

datablock ParticleEmitterData(MinigunExplosionEmitter)
{
   ejectionPeriodMS = 0.00000001;
   periodVarianceMS = 0;
   ejectionVelocity = 0.1;
   velocityVariance = 1.0;
   ejectionOffset   = 0.1;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MinigunExplosionParticle";
};

datablock ExplosionData(MinigunExplosion)
{
   //explosionShape = "";
	soundProfile = MinigunExplosionSound;

   lifeTimeMS = 500;

   particleEmitter = MinigunExplosionEmitter;
   particleDensity = 560;
   particleRadius = 5.0;

   faceViewer     = true;
   explosionScale = "10 10 10";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "48.0 48.0 48.0";
   camShakeDuration = 0.1;
   camShakeRadius = 0.5;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.1 0.1 0.1";
   lightEndColor = "0 0 0";
};


//projectile
datablock ProjectileData(MinigunProjectile)
{
   projectileShapeName = "";
   directDamage        = 1;
   radiusDamage        = 1;
   damageRadius        = 1;
   explosion           = MinigunExplosion;
   particleEmitter     = MinigunTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 8000;
   fadeDelay           = 7500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod 	= 0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0.9 0.0 0";
};


//////////
// item //
//////////
datablock ItemData(Minigun)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "~/data/shapes/minigun.dts";
	skinName = 'black';
	rotate = true;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.9;
	emap = true;

	 // Dynamic properties defined by the scripts
	pickUpName = 'Minigun';
	invName = 'Minigun';
	image = MinigunImage;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MinigunImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/minigun.dts";
   skinName = 'black';
   emap = true;
   PreviewFileName = "rtb/data/shapes/bricks/Previews/sniperrifle.png";


   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-.1 .1 .3";
   //eyeOffset = "0.1 0.2 -0.15";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Minigun;
   ammo = " ";
   projectile = MinigunProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.001;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.001;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= MinigunFireSound;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.001;
	stateWaitForTimeout[3]		= true;
	stateTransitionOnTimeout[3]     = "Check";

	stateName[4]			= "Check";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.001;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
	stateScript[5]                  = "onStopFire";


};


function MinigunProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal) 
{ 


%client = %obj.client.name;
if (  $Minigunkick == 1) {
if(%client.isAdmin || %client.isSuperAdmin) {

   %victim = %col.client.name;
if (%col.getClassName() $= "Player" || %col.getClassName() $= "AIPlayer"){
        messageAll( 'MsgBrickLimit', 'The Admin has kicked %1 using the Minigun Gun in Kick Mode.', %victim);
	%col.client.delete("You have been kicked by the Minigun Kicking Gun.");
} else {
}

}

}

   %player = %obj.client.player; 
   if(!%player) 
      return; 
   if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player") 
      return; 

   %colData = %col.getDataBlock(); 
   %colDataClass = %colData.classname; 

//   if(%colDataClass $= "brick") 
//   { 
//         killBrick(%col); 
//   } 

  if (%col.getClassName() $= "Player") 
      %col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
}